KTabEdit ChangeLog

Please refer to 
http://en.wikipedia.org/wiki/Changelog
for the format of the ChangeLog
================================================================================

2008-04-25 Claudiu Covaci <claudiu.covaci@gmail.com>
	* src/ktabedit.{h, cpp} : added function showAboutBox()
	* more documentation changes (again, style- and doxygen-conform)
	* removed KDevelop files because there was, afterall, no benefit from adding them. If a developer wants to use KDevelop, he or she can easily import the project in Kdevelop (see its documentation)

2008-04-25 Claudiu Covaci <claudiu.covaci@gmail.com>
	* src/ktabedit.{h, cpp} : put code for creating Menus, Actions, Toolbars in one function respectively (no change in functionality)
	* small changes to the documentation and some parameter fixes doxygen warned about

2008-04-24 Claudiu Covaci <claudiu.covaci@gmail.com>
	* added KDevelop project files (using KDevelop 3.5.0 on KDE 3.5.8)
	* small fixes in the documentation

2008-04-22 Claudiu Covaci <claudiu.covaci@gmail.com>
	* Doxyfile: upgraded and removed absolute paths

2006-10-06 Gwena�l Casaccio <mrgwen@gmail.com>
	* Correct the supports of the click on the screen
	* Add a new class TrackClassicalDuration draw the duration for
	the classical notation
	* Correct the visual drawing
	* Go to the bar and time when you click on the screen
	* New icons and web site thanks to Ollivier Lapeyre Johann
	<johann.ollivierlapeyre@gmail.com>

2006-09-22 Gwena�l Casaccio <mrgwen@gmail.com>
	* Add a support of the precompiled headers (make pch)
	* Initial printing support (only with 75 dpi at this time)
	* Add a logger class which saves the log in the file ktabedit.log 
	inside ($HOME)/.ktabedit/
	* Global header file for all the Qt and Kde classes (header.h)
	* Setup the printer inside SongView
	* Initial support of the cursor tracking with the class
	PlayBackTracker
	* Remove the old code from SongPrint and use the new render engines
	* Update the view when a playbackCursor message is send in the class
	SongView
	* Add a new class TrackBarLineView draw the measure line
	* Add a new class TrackBarView draw the bar (classical and/or
	tablature view)
	* Add a new class TrackClassicalClefView draw the duration of a time
	* Add a new class TrackEditView used for the edition and the
	repainting of the view
	* Add a new class TrackPageView draw a page and the page number
	* Add a new class TrackTabClefView draw the word "TAB"
	* Add a new class TrackTimesClassicalView draw the classical view and
	converts the tablature in notes
	* Add a new class TrackTimesSignatureView draw the time signature
	* Add a new class TrackTimesView display the tab number for a time
	* Add a new class TrackTitleView draw the title
	* Add a new class TrackTuningView draw the tuning
	* Add a new class TrackWordsAndMusicView display "words and music by "
	* Add a new class Unit converts different units i.e. pixel in cm 
	
2006-04-18 Gwena�l Casaccio <mrgwen@gmail.com>
	* Add a wizard to config the midi support
	* Initial support for powerTab (1.00 -> 1.7)
	* Improve the tuplet support in midi playing
	
2006-03-01 Gwena�l Casaccio <mrgwen@gmail.com>
	* Add a better support of the guitar pro 3 & 4 file support in
	the framework
	* A lot of changing in the framework
	* Support of x / 8, x / 16, ... measures
	* Change the format of the ktabedit files (compressed xml files)
	* Correct two bugs in the player
	* Change the TrackViewCommand class
	* Correct a stupid bug in the trackprint (the tunning of the song was inversed)
	* Correct a in the timidity launcher (add a new field for the real time support or not)

2006-01-10 Gwena�l Casaccio <mrgwen@gmail.com>
	* Correct a stupid bug in songview.cpp
	* Add a initial support for the key in guitar pro
	
2006-01-06 Gwena�l Casaccio <mrgwen@gmail.com>
	* Improve the guitar pro 3 & 4 importer, it imports now the
	volume, balance, ... properties.
	* Support the volume, balance properties and support these properties
	in the midi player.
	* Improve the tse3 error handler.
	* Correct a bug in the options dialog.
	
2005-11-30 Gwena�l Casaccio <mrgwen@gmail.com>
	* Improve the guitar pro 3 & 4 importer, it imports correctly
	the midi patch property, and the drum
	* Improve the midi playing.
	* You can configure timidity and ktabedit check if timidity is launched correctly.
	* Remove alsa support.
	
2005-11-04 Gwena�l Casaccio <mrgwen@gmail.com>
	* Improve the scrolling code.
	* You can click on the score.
	
2005-03-14 Gwena�l Casaccio <mrgwen@gmail.com>
	* Release 0.1.5
	* Midi playing
	
2005-03-14 Gwena�l Casaccio <gwenaelcasaccio@msn.com>
	* Release 0.0.3
	* Write a doxygen documentation
	* Change the internal structure of the project (add new dirs)
	* Change the autoconf, automake, ... version needed (can compile with autoconf-2.13,
	autoheader-2.13, automake-1.4)
	
2005-02-23 Gwena�l Casaccio <gwenaelcasaccio@msn.com>
	* Release 0.0.2
	* Improve the drawing code.
	
2005-01-17 Gwena�l Casaccio <gwenaelcasaccio@msn.com>
	* Initial release 0.0.1
	* Lots of refactoring in internal APIs
	
KGuitar changelog :
===================

2003-08-27 Mikhail Yakshin <greycat@users.sourceforge.net>

	* Release 0.4.9

	* First release in a very long time. Lots of work-in-progress
	features, could be buggy somewhere, could lacks obvious features,
	etc, etc. However, it's a major step to 0.5 since year-ago
	0.4.1. Lots of new and unique great features.

	* Official port to KDE3. Now KGuitar requires KDE 3.x and Qt 3.x
	to build and run. Also we've transitioned to newer build tools -
	automake 1.7, autoconf 2.5, gcc 3.2.

	* Introduced basic KDE help center documentation. Needs much more
	work, any volunteers are certainly welcome. However, current
	documentation covers as much as possible from old simple README
	file.

	* More usability features. Now, KGuitar has Ctrl-Minus and
	Ctrl-Plus shortcuts to zoom in and zoom out horizontal scale of
	tabulatures. More generic navigation keys working: Home and End go
	to the start and the end of current bar respectively, Ctrl-Home
	and Ctrl-End go to the start & end of current track.

	* Melody editor - a brand new tool to help entering tabulature
	with mouse. Somewhat loosely resembles Cakewalk's tab staff
	fretboard, but much more useful & flexible. Editor looks like
	fretboard where you can set fingers with mouse, add power chords
	or enter solos really fast by just clicking necessary block
	patterns on the fret in order. Fully customizable, now supports
	several inlay types. Work in progress, so more to come.

	* Rhythm constructor - it's a tool that helps you find and
	understand the given rhythm. You just tap the necessary rhythmic
	pattern using your mouse or keyboard button, wizard records all
	delays between taps in real time and then uses sophisticated
	algorithm to help you determine that's the right tempo to that
	beat and what note durations should you use. If you want, you can
	apply resulting beats to your tabulature columns - a great way to
	add rhythmic information to ASCII tabs without such info!
	
	* Support for native Qt tabulature printing - pretty complete,
	with effects and, what's more important, with additional fonts it
	can output standard notescore notation from tabulatures. Support
	for key signatures is a bit simplified, work-in-progress.

	* More complete MIDI playback feature - now with monitoring of
	what's played, however, slightly buggy. For best results, try
	playing from the very beginning of the song.
	
	* More complete MusicXML support.

	* Guitar Pro 3 import support from Sylvian & Thiery
	Vignaud(s). Doesn't work it all cases, but can handle relatively
	simple gp3 files well.
	
	* Lots of refactoring in internal APIs, classes, etc, including
	more versatile options interface.

	* Numerous fixes for screen glitches, anti-aliasing, chord
	constructor, track pane almost completely rewritten to be more
	robust, etc.
	
2002-07-13 Mikhail Yakshin <greycat@users.sourceforge.net>

	* Release 0.4.1

	* Fixed lots of TSE3 issues. Now KGuitar requires TSE3 0.2.x
	(0.2.3 or later recommended) to work and its MIDI capabilties are
	solely based on TSE3. All the stuff that works with MIDI (MIDI
	export, MIDI song playback, chord player, etc) were unified under
	the control of single TSE3 library and nothing else. Should work
	with most if not all available Unix MIDI interfaces: both older
	and newer ALSA, OSS, aRts, etc.

	* Added configuration options for TSE3 playing and exporting of
	TSE3MDL file format. MIDI export is rewritten using TSE3
	functions - now it should be more flexible.

	* Basic MusicXML support. MusicXML is leading interchange format
	for exchanging musical data between various applications. For more
	info, see www.recordare.com.

	* Native tabulature printing with Qt/KDE interfaces with effect
	support, multi-track & multi-page printing.

	* New tabulature effects and features: slide, triplets, let ring.

	* Added basic and pretty faulty, but somewhat working for simple
	files Guitar Pro 2 import support. Any assistance with hacking on
	more features of this format is welcome.

	* Slight sorting of chords in chord constructor: better chords are
	on top.
	
	* Lots of bug fixes, more ideological tweaking.

2001-12-10 Mikhail Yakshin <greycat@users.sourceforge.net>

	* Release 0.4

	* Major change in whole application song handling ideology, now
	it's much straighter. MIDI output reworked to follow new model.

	* Implemented multitracking support -- with all the necessary
	things list separate track listing panel, inserting/removing
	unlimited amount of tracks, separate track navigation panel, etc,
	etc.

	* Implemented basically functional drum track mode.

	* Added special feature for automatic bass line generation from
	rhythm track.
	
	* Added editing options: cut, copy & paste, undo/redo. Selections
	are possible with Shift + arrow keys.

	* New strumming pattern rule --- much more flexible now, allowing
	chords or parts of chords rhythms.
	
	* Much more accurate and less flicker-prone tabulature redrawing
	code --- now repaints only things that are needed to be
	repainted. Many more convenience options, like fast navigation via
	track navigation panel and ensuring that cursor is always visible.

	* Lots of various bugfixes, especially with chord constructor and
	track integrity.

2001-09-22 Alexander Brand  <alinx@users.sourceforge.net>

	* Release 0.3-pre

	* Changed automake/autoconf stuff to KDE2 standard one in admin directory.

	* Ported to KParts as browser extension. The KGuitar tab view is now a
	KPart. KG-files can viewed with Konqueror like PDF-Files.

	* MIDI playback support (required libkmid to compile - it's available in
	kdelibs-sound package). Basic MIDI playback implemented in chord constructor
	and tabulature view. It's a new unstable feature and feedback about it (how
	it works on different systems/soundcards) is highly appreciated.

	* Added option in configure script: MIDI playback for tabs
	can be enabled with './configure --with-midisupport'

	* Added MIDI options.

	* New strumming shemes are added.

	* Moved file export/import to file save/open.

	* Added drum track mode template - basically function-less, but it's a
	template for further track modes coming in future.

	* Up-to-date translation for de, fr, it.


2000-11-09 Mikhail Yakshin <yakshin@online.ru>

	* Release 0.2.9

	* Port to KDE2

2000-10-14  Mikhail Yakshin  <yakshin@online.ru>

	* Release 0.2.1

	* Lots of work done in separated mini-project (developing ALSA
	sequencing C++ classes for MIDI playback), though in this branch
	lots of changes too.

	* Loading and saving options implemented (at last)

	* Working MIDI export - lots of work, but it worthed it. Exports
	in MIDI files, format 0. Honors all track properties and some
	effects (harmonics).

	* Renewed resizable chord dialog made with layouts.	

	* Strumming patterns in chord constructor. Now it's possible to
	insert a chord as an arpegio or picked with pre-defined
	pattern. Small library of patterns is supplied with this version.
	
	* Tabulature printing via MusiXTeX and custom macros. You'll need
	to export the song via "Export/MusiXTeX tab" and then you get a
	ready-to-use tex-file. Process it with TeX as usual and print it.

	* Several new tunings in library, including banjo, mandolin and
	brahms 8-string guitar.
	
	* Fixed several bugs, fixed "mixed" notenames (with proper
	sharp/flat combinations), etc.

2000-09-08  Mikhail Yakshin  <yakshin@online.ru>

	* Release 0.2

	* Second big milestone release. Lots of changes, a month of work.

	* Total rewrite of internal track structures to use dynamic arrays
	(QArrays) instead of lists. List stuff was really ugly and hard to
	use (tabs really require direct access due to its nature). These
	changes touched almost every piece of code, including saving /
	loading schemes, tab displaying and more.
	
	* Tabulature editor: improved greatly.

	* It understands now various time signatures and separation of
	whole music piece in measures. Columns can have various durations,
	including dotted durations (1.5x the duration, as in classic
	notescores) and linked durations (to make possible weird durations
	such as 5/16 or something like that).

	* Automatical bar arranger that understands splitting notes of bar
	margins (with linking) and simplifying the tab by joining similiar
	columns into one. Note duration bars are linked in classic notes
	manner.
	
	* Basic mouse navigation to those who find keyboard navigation
	hard to use.

	* Basic effect support, just to demonstrate the technology.
	Current effects include natural and artificial harmonics and
	legato. More effects should be added soon.

	* Toolbar and statusbar made more functional. Statusbar now shows
	the current bar number and toolbar pretends to have useful
	buttons.

	* Various note naming, american (CDEFGAB), european (CDEFGAH) and
	jazz schemes (CDEFGABH), with various flats & sharps.

	* I18n suport. This release has ru and fr program message i18n
	files (po-files).

	* Chord construction is improved too: chord list comes sorted now
	(from the simpliest name to the most sophisticated), selecting a
	chord name there makes all necessary selections, reduced
	flickering. Many programming optimizations and clarifications
	mostly invisible to the user.

	* Tunings: added new tunings, fixed string thickness scale to be
	more informative.

	* Lots of bug fixes.

2000-08-08  Mikhail Yakshin  <yakshin@glasnet.ru>

	* Release 0.1

	* The first official public version. This one should be announced
	on Freshmeat and that kind of sites.

	* New basic tabulature editor. It still lacks some extended
	features like full support of effects, but the basic functionality
	is here and ready to use. Right now it's controlled only by
	keyboard, so take a look at the keyboard controls in the README
	file.

	* Chord finder is optimized much more. On my P200 it works as fast
	as Guitar Pro's one, but our version has much more features. Chord
	dialog code was cleanded up a little and new chord inversion
	control was added - be sure to check it out! Bass note control
	still isn't here, just because I couldn't find anywhere the
	accurate music theory definition of alternating bass note chords.

	* Songs could be saved and loaded in KG format (KGuitar native
	format). This format is pretty extensible and flexible and should
	be as backward compatible as possible.

	* Songs have the following properties: title, author name,
	transcriber name, comments.

	* Everything's ready for multiple tracks, though in this release
	I've not made a multitracking yet. You can edit the properties of
	each track using Edit/Track dialog, including the number and
	tuning of strings (be sure to check out the cool string thickness
	icons), number of frets, etc.

	* Pretty working exporting to ASCII tabs, so you can type in your
	tabulatures easily in KGuitar and export it to internet text-only
	form for wide usage. Importing ASCII tabs is on the way.

	* Exporting MIDI code is there, but it has fatal bugs and thereby
	disabled. If you want to play with it - enable it in sources, but
	it's broken.

	* Small options dialog just to show what degree of customizability
	we plan to implement in KGuitar. You can choose what symbols to
	describe dominant 7th chords you like the most and what symbols
	should be used for note alteration.

	* Lots of bugfixes, check the CVS logs if you care.

2000-07-15  Mikhail Yakshin  <yakshin@glasnet.ru>

	* Release 0.0.2
	
	* A working release, could be helpful for somebody. Includes a pretty	
	  good chord dialog, with both chord finder and chord analyzer almost
	  totally rewritten.

	* Chord finder now works *much* faster due to precalculation. Interface
	  allows to find most chords (like major/minor, 7th, sus2, sus4, 9, 11,
	  etc). Filter found chord, based on its complexity on 3 basises: usual
	  chords, rare chords and all chords. Also, takes care about showing
	  only root forms (tonic note is bass note).
	
	* Chord analyzer now works totally different, it tries to disassemble
	  a chord from a tonic note to steps, and then assembles step record
	  again into readable chord form, thus detecing very weird (but
	  sometimes useful chord forms, such as Em6/9sus4 or C7add11 (no3)).
	  Compared to Guitar Pro chord analyzer that works on similiar concepts,
	  this chord analyzer detects more chord forms (but currently lacks
	  changed bass note detection, like Dm/E).
	
2000-07-08  Mikhail Yakshin  <yakshin@glasnet.ru>

	* Release 0.0.1
	
	* Initial release
